gi-gtk4-4.0.12: Gtk 4.x bindings

Copyright | Will Thompson and Iñaki García Etxebarria
License | LGPL-2.1
Maintainer | Iñaki García Etxebarria
Safe Haskell | None
Language | Haskell2010

GI.Gtk.Objects.SizeGroup

Contents

- Exported types
- Methods
  - addWidget
  - getMode
  - getWidgets
  - new
  - removeWidget
  - setMode
- Properties
  - mode

Description

Groups widgets together so they all request the same size.

This is typically useful when you want a column of widgets to have the same size, but you can’t use a `Grid` or `Box`.

In detail, the size requested for each widget in a `GtkSizeGroup` is the maximum of the sizes that would have been requested for each widget in the size group if they were not in the size group. The [mode]`sizeGroupSetMode` of the size group determines whether this applies to the horizontal size, the vertical size, or both sizes.

Note that size groups only affect the amount of space requested, not the size that the widgets finally receive. If you want the widgets in a `GtkSizeGroup` to actually be the same size, you need to pack them in such a way that they get the size they request and not more. In particular it doesn't make a lot of sense to set [the expand flags]`widgetSetHexpand` on the widgets that are members of a size group.

`GtkSizeGroup` objects are referenced by each widget in the size group, so once you have added all widgets to a `GtkSizeGroup`, you can drop the initial reference to the size group with `objectUnref`. If the widgets in the size group are subsequently destroyed, then they will be removed from the size group and drop their references on the size group; when all widgets have been removed, the size group will be freed.

Widgets can be part of multiple size groups; GTK will compute the horizontal size of a widget from the horizontal requisition of all widgets that can be reached from the widget by a chain of size groups with mode `SizeGroupModeHorizontal` or `SizeGroupModeBoth`, and the vertical size from the vertical requisition of all widgets that can be reached from the widget by a chain of size groups with mode `SizeGroupModeVertical` or `SizeGroupModeBoth`.

# Size groups and trading height-for-width

::: warning Generally, size groups don't interact well with widgets that trade height for width (or width for height), such as wrappable labels. Avoid using size groups with such widgets.

A size group with mode `SizeGroupModeHorizontal` or `SizeGroupModeVertical` only consults non-contextual sizes of widgets other than the one being measured, since it has no knowledge of what size a widget will get allocated in the other orientation. This can lead to widgets in a group actually requesting different contextual sizes, contrary to the purpose of `GtkSizeGroup`.

In contrast, a size group with mode `SizeGroupModeBoth` can properly propagate the available size in the opposite orientation when measuring widgets in the group, which results in consistent and accurate measurements.

In case some mechanism other than a size group is already used to ensure that widgets in a group all get the same size in one orientation (for example, some common ancestor is known to allocate the same width to all its children), and the size group is only really needed to also make the widgets request the same size in the other orientation, it is beneficial to still set the group's mode to `SizeGroupModeBoth`. This lets the group assume and count on sizes of the widgets in the former orientation being the same, which enables it to propagate the available size as described above.

# Alternatives to size groups

Size groups have many limitations, such as only influencing size requests but not allocations, and poor height-for-width support. When possible, prefer using dedicated mechanisms that can properly ensure that the widgets get the same size.

Various container widgets and layout managers support a homogeneous layout mode, where they will explicitly give the same size to their children (see Box:homogeneous). Using homogeneous mode can also have large performance benefits compared to either the same container in non-homogeneous mode, or to size groups.

`Grid` can be used to position widgets into rows and columns. Members of each column will have the same width among them; likewise, members of each row will have the same height. On top of that, the heights can be made equal between all rows with Grid:rowHomogeneous, and the widths can be made equal between all columns with Grid:columnHomogeneous.

# GtkSizeGroup as GtkBuildable

Size groups can be specified in a UI definition by placing an `<object>` element with `class="GtkSizeGroup"` somewhere in the UI definition. The widgets that belong to the size group are specified by a `<widgets>` element that may contain multiple `<widget>` elements, one for each member of the size group. The ”name” attribute gives the id of the widget.

An example of a UI definition fragment with `GtkSizeGroup`:

### xml code

    <object class="GtkSizeGroup">
      <property name="mode">horizontal</property>
      <widgets>
        <widget name="radio1"/>
        <widget name="radio2"/>
      </widgets>
    </object>

Synopsis

- newtype SizeGroup = SizeGroup (ManagedPtr SizeGroup)
- class (GObject o, IsDescendantOf SizeGroup o) => IsSizeGroup o
- toSizeGroup :: (MonadIO m, IsSizeGroup o) => o -> m SizeGroup
- sizeGroupAddWidget :: (HasCallStack, MonadIO m, IsSizeGroup a, IsWidget b) => a -> b -> m ()
- sizeGroupGetMode :: (HasCallStack, MonadIO m, IsSizeGroup a) => a -> m SizeGroupMode
- sizeGroupGetWidgets :: (HasCallStack, MonadIO m, IsSizeGroup a) => a -> m [Widget]
- sizeGroupNew :: (HasCallStack, MonadIO m) => SizeGroupMode -> m SizeGroup
- sizeGroupRemoveWidget :: (HasCallStack, MonadIO m, IsSizeGroup a, IsWidget b) => a -> b -> m ()
- sizeGroupSetMode :: (HasCallStack, MonadIO m, IsSizeGroup a) => a -> SizeGroupMode -> m ()
- constructSizeGroupMode :: (IsSizeGroup o, MonadIO m) => SizeGroupMode -> m (GValueConstruct o)
- getSizeGroupMode :: (MonadIO m, IsSizeGroup o) => o -> m SizeGroupMode
- setSizeGroupMode :: (MonadIO m, IsSizeGroup o) => o -> SizeGroupMode -> m ()

# Exported types

newtype SizeGroup Source #

Memory-managed wrapper type.

Constructors

SizeGroup (ManagedPtr SizeGroup) |

#### Instances

Instances details

Eq SizeGroup Source # |
Instance details Defined in GI.Gtk.Objects.SizeGroup Methods (==) :: SizeGroup -> SizeGroup -> Bool Source # (/=) :: SizeGroup -> SizeGroup -> Bool Source #
GObject SizeGroup Source # |
Instance details Defined in GI.Gtk.Objects.SizeGroup
ManagedPtrNewtype SizeGroup Source # |
Instance details Defined in GI.Gtk.Objects.SizeGroup Methods toManagedPtr :: SizeGroup -> ManagedPtr SizeGroup Source #
TypedObject SizeGroup Source # |
Instance details Defined in GI.Gtk.Objects.SizeGroup Methods glibType :: IO GType Source #
HasParentTypes SizeGroup Source # |
Instance details Defined in GI.Gtk.Objects.SizeGroup
IsGValue (Maybe SizeGroup) Source # | Convert `SizeGroup` to and from `GValue`. See `toGValue` and `fromGValue`.
Instance details Defined in GI.Gtk.Objects.SizeGroup Methods gvalueGType_ :: IO GType Source # gvalueSet_ :: Ptr GValue -> Maybe SizeGroup -> IO () Source # gvalueGet_ :: Ptr GValue -> IO (Maybe SizeGroup) Source #
type ParentTypes SizeGroup Source # |
Instance details Defined in GI.Gtk.Objects.SizeGroup type ParentTypes SizeGroup = '[Object, Buildable]

class (GObject o, IsDescendantOf SizeGroup o) => IsSizeGroup o Source #

Type class for types which can be safely cast to `SizeGroup`, for instance with `toSizeGroup`.

#### Instances

Instances details

(GObject o, IsDescendantOf SizeGroup o) => IsSizeGroup o Source # |
Instance details Defined in GI.Gtk.Objects.SizeGroup

toSizeGroup :: (MonadIO m, IsSizeGroup o) => o -> m SizeGroup Source #

Cast to `SizeGroup`, for types for which this is known to be safe. For general casts, use `castTo`.

# Methods

### Click to display all available methods, including inherited ones

Expand

#### Methods

addWidget, bindProperty, bindPropertyFull, forceFloating, freezeNotify, getv, isFloating, notify, notifyByPspec, ref, refSink, removeWidget, runDispose, stealData, stealQdata, thawNotify, unref, watchClosure.

#### Getters

getBuildableId, getData, getMode, getProperty, getQdata, getWidgets.

#### Setters

setData, setDataFull, setMode, setProperty.

## addWidget

sizeGroupAddWidget Source #

Arguments

:: (HasCallStack, MonadIO m, IsSizeGroup a, IsWidget b) |
=> a | `sizeGroup`: a `GtkSizeGroup`
-> b | `widget`: the `GtkWidget` to add
-> m () |

Adds a widget to a `GtkSizeGroup`.

In the future, the requisition of the widget will be determined as the maximum of its requisition and the requisition of the other widgets in the size group. Whether this applies horizontally, vertically, or in both directions depends on the mode of the size group. See `sizeGroupSetMode`.

When the widget is destroyed or no longer referenced elsewhere, it will be removed from the size group.

## getMode

sizeGroupGetMode Source #

Arguments

:: (HasCallStack, MonadIO m, IsSizeGroup a) |
=> a | `sizeGroup`: a `GtkSizeGroup`
-> m SizeGroupMode | Returns: the current mode of the size group.

Gets the current mode of the size group.

## getWidgets

sizeGroupGetWidgets Source #

Arguments

:: (HasCallStack, MonadIO m, IsSizeGroup a) |
=> a | `sizeGroup`: a `GtkSizeGroup`
-> m [Widget] | Returns: a `GSList` of widgets. The list is owned by GTK and should not be modified.

Returns the list of widgets associated with `sizeGroup`.

## new

sizeGroupNew Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> SizeGroupMode | `mode`: the mode for the new size group.
-> m SizeGroup | Returns: a newly created `GtkSizeGroup`

Create a new `GtkSizeGroup`.

## removeWidget

sizeGroupRemoveWidget Source #

Arguments

:: (HasCallStack, MonadIO m, IsSizeGroup a, IsWidget b) |
=> a | `sizeGroup`: a `GtkSizeGroup`
-> b | `widget`: the `GtkWidget` to remove
-> m () |

Removes a widget from a `GtkSizeGroup`.

## setMode

sizeGroupSetMode Source #

Arguments

:: (HasCallStack, MonadIO m, IsSizeGroup a) |
=> a | `sizeGroup`: a `GtkSizeGroup`
-> SizeGroupMode | `mode`: the mode to set for the size group.
-> m () |

Sets the `GtkSizeGroupMode` of the size group.

The mode of the size group determines whether the widgets in the size group should all have the same horizontal requisition (`SizeGroupModeHorizontal`) all have the same vertical requisition (`SizeGroupModeVertical`), or should all have the same requisition in both directions (`SizeGroupModeBoth`).

# Properties

## mode

The direction in which the size group affects requested sizes.

constructSizeGroupMode :: (IsSizeGroup o, MonadIO m) => SizeGroupMode -> m (GValueConstruct o) Source #

Construct a `GValueConstruct` with valid value for the “`mode`” property. This is rarely needed directly, but it is used by `new`.

getSizeGroupMode :: (MonadIO m, IsSizeGroup o) => o -> m SizeGroupMode Source #

Get the value of the “`mode`” property. When overloading is enabled, this is equivalent to

    get sizeGroup #mode

setSizeGroupMode :: (MonadIO m, IsSizeGroup o) => o -> SizeGroupMode -> m () Source #

Set the value of the “`mode`” property. When overloading is enabled, this is equivalent to

    set sizeGroup [ #mode := value ]